# This file is part of  Build Your Own CI
#

# Copyright 2017, 2018 Vincent Ladeuil
# Copyright 2016, 2017 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 3, as published by the
# Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
# SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import sys

import byov


from byov import config


# Using realpath below as __file__ may include a symlink
HERE = os.path.realpath(os.path.dirname(__file__))
BRANCH_ROOT = os.path.abspath(os.path.join(HERE, '..'))


# We want byoci config files on top of the byov ones
if BRANCH_ROOT not in byov.path:
    byov.path.append(BRANCH_ROOT)
    config.import_user_byov_from(os.path.join(BRANCH_ROOT, 'byov.conf.d'))
# We want to import byoci
sys.path.insert(0, BRANCH_ROOT)

# FIXME: inlining byoci.host.options here and moving byoci.options to byov may
# be a better solution -- vila 2018-10-19
# FIXME: Come on I just set sys.path above so the following import can succeed,
# surely pep8 shouldn't complain ? -- vila 2018-10-19
from byoci.host import options  # noqa

# Registering the options requires importing them, this is purely declarative.
options = options
