#!/usr/bin/env python3

# FIXME: Ideally byov will learn to import and execute directly
# -- vila 2018-02-17

# This file is part of Build Your Own CI
#
# Copyright 2018 Vincent Ladeuil
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 3, as published by the
# Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
# SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program.  If not, see <http://www.gnu.org/licenses/>.

# /!\ This is expanded by byov, caveat emptor

import logging
import os
import sys


logger = logging.getLogger(__name__)
sys.path.insert(0, '{{byoci}.host.definition}')


# FIXME: Come on... I just set sys.path above so the following import can
# succeed, surely pep8 shouldn't complain ? -- vila 2018-02-17
from byoci.host import (  # noqa
    config,
    commands,
)


# Acquire a few options from the master for the monitor.
def set_options_from_master(monitor):
    logger.debug('Setting monitor options from master ones.')
    # Save the api url and token in the existing vms config file so they live
    # as long as the vm.
    monitor.existing_vm_options.extend([
        '{byoci}.master.api',
        '{byoci}.monitor.token'
    ])
    master_conf = config.VmStack('{{byoci}.master}')
    kls = master_conf.get('vm.class')
    master = kls(master_conf)
    token_path = os.path.join(master_conf.get('jenkins.tokens'),
                              'monitor-api-token')
    ret, out, err = master.shell_captured('cat', token_path)
    monitor.conf.set('{byoci}.monitor.token', out)
    # Getting the master.api from the master config allows the master vm.ip to
    # be used (and expanded) in the option definition. This can then be copied
    # to the monitor configuration.
    monitor.conf.set('{byoci}.master.api',
                     master_conf.get('{byoci}.master.api'))
    monitor.save_existing_config()


if __name__ == '__main__':
    commands.setup_logging('{logging.level}'.upper())
    monitor_conf = config.VmStack('{vm.name}')
    monitor = monitor_conf.get('vm.class')(monitor_conf)
    set_options_from_master(monitor)
